/*----- PROTECTED REGION ID(DaresburyClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        DaresburyClass.cpp
//
// description : C++ source for the DaresburyClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Daresbury once per process.
//
// project :     Daresbury
//s
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <DaresburyClass.h>

/*----- PROTECTED REGION END -----*/	//	DaresburyClass.cpp

//-------------------------------------------------------------------
/**
 *	Create DaresburyClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Daresbury_class(const char *name) {
		return Daresbury_ns::DaresburyClass::init(name);
	}
}

namespace Daresbury_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
DaresburyClass *DaresburyClass::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
constexpr long InterlocksAttrib::X_DATA_SIZE;
//--------------------------------------------------------
/**
 * method : 		DaresburyClass::DaresburyClass(std::string &s)
 * description : 	constructor for the DaresburyClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
DaresburyClass::DaresburyClass(std::string &s):Tango::DeviceClass(s)
{
	TANGO_LOG_INFO << "Entering DaresburyClass constructor" << std::endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(DaresburyClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::constructor

	TANGO_LOG_INFO << "Leaving DaresburyClass constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		DaresburyClass::~DaresburyClass()
 * description : 	destructor for the DaresburyClass
 */
//--------------------------------------------------------
DaresburyClass::~DaresburyClass()
{
	/*----- PROTECTED REGION ID(DaresburyClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		DaresburyClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
DaresburyClass *DaresburyClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new DaresburyClass(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		DaresburyClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
DaresburyClass *DaresburyClass::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		DevReadClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DevReadClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "DevReadClass::execute(): arrived" << std::endl;
	return insert((static_cast<Daresbury *>(device))->dev_read());
}

//--------------------------------------------------------
/**
 * method : 		GetAllDescriptionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetAllDescriptionClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "GetAllDescriptionClass::execute(): arrived" << std::endl;
	return insert((static_cast<Daresbury *>(device))->get_all_description());
}

//--------------------------------------------------------
/**
 * method : 		GetHistoryInfoClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetHistoryInfoClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "GetHistoryInfoClass::execute(): arrived" << std::endl;
	return insert((static_cast<Daresbury *>(device))->get_history_info());
}

//--------------------------------------------------------
/**
 * method : 		GetInterlockDescriptionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetInterlockDescriptionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "GetInterlockDescriptionClass::execute(): arrived" << std::endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<Daresbury *>(device))->get_interlock_description(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetInterlockStateClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetInterlockStateClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "GetInterlockStateClass::execute(): arrived" << std::endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<Daresbury *>(device))->get_interlock_state(argin));
}

//--------------------------------------------------------
/**
 * method : 		ReadInterlockHistoryClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ReadInterlockHistoryClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "ReadInterlockHistoryClass::execute(): arrived" << std::endl;
	Tango::DevLong argin;
	extract(in_any, argin);
	return insert((static_cast<Daresbury *>(device))->read_interlock_history(argin));
}

//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ResetClass::execute(): arrived" << std::endl;
	((static_cast<Daresbury *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetInterlockDescriptionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetInterlockDescriptionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "SetInterlockDescriptionClass::execute(): arrived" << std::endl;
	const Tango::DevVarStringArray *argin;
	extract(in_any, argin);
	((static_cast<Daresbury *>(device))->set_interlock_description(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		EnableSMSClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *EnableSMSClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "EnableSMSClass::execute(): arrived" << std::endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	((static_cast<Daresbury *>(device))->enable_sms(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DisableSMSClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DisableSMSClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "DisableSMSClass::execute(): arrived" << std::endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	((static_cast<Daresbury *>(device))->disable_sms(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetSMSClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetSMSClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "GetSMSClass::execute(): arrived" << std::endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<Daresbury *>(device))->get_sms(argin));
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum DaresburyClass::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum DaresburyClass::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum DaresburyClass::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::get_class_property()
 *	Description: Read database to initialize class property data members.
 */
//--------------------------------------------------------
void DaresburyClass::get_class_property()
{
	/*----- PROTECTED REGION ID(DaresburyClass::get_class_property_before) ENABLED START -----*/
	
	//	Initialize class property data members
	sMSDevice = "";
	sMSPhoneNumber = "";
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::get_class_property_before
	//	Read class properties from database.
	cl_prop.push_back(Tango::DbDatum("SMSDevice"));
	cl_prop.push_back(Tango::DbDatum("SMSPhoneNumber"));
	cl_prop.push_back(Tango::DbDatum("MailDest"));

	//	Call database and extract values
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;

	//	Try to extract SMSDevice value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  sMSDevice;
	else
	{
		//	Check default value for SMSDevice
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  sMSDevice;
			cl_prop[i]  <<  sMSDevice;
		}
	}
	//	Try to extract SMSPhoneNumber value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  sMSPhoneNumber;
	else
	{
		//	Check default value for SMSPhoneNumber
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  sMSPhoneNumber;
			cl_prop[i]  <<  sMSPhoneNumber;
		}
	}
	//	Try to extract MailDest value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  mailDest;
	else
	{
		//	Check default value for MailDest
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  mailDest;
			cl_prop[i]  <<  mailDest;
		}
	}
	/*----- PROTECTED REGION ID(DaresburyClass::get_class_property_after) ENABLED START -----*/
	
	//	Check class property data members init
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::get_class_property_after

}

//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void DaresburyClass::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties
	prop_name = "SMSDevice";
	prop_desc = "Name of the SMS device";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "SMSPhoneNumber";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "MailDest";
	prop_desc = "List of mail adress";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);

	//	Set Default device Properties
	prop_name = "Serial_line";
	prop_desc = "Name of the serial line device";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Init_pscom";
	prop_desc = "Flag to force reinitialisation (This is needed on certain old daresbury board)\nDefault is 0 => no initialisation";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void DaresburyClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("Daresbury");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("Handle PSS crate hardware");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void DaresburyClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(DaresburyClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new Daresbury(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Daresbury *dev = static_cast<Daresbury *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(DaresburyClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void DaresburyClass::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(DaresburyClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::attribute_factory_before
	//	Attribute : Interlocks
	InterlocksAttrib	*interlocks = new InterlocksAttrib();
	Tango::UserDefaultAttrProp	interlocks_prop;
	//	description	not set for Interlocks
	//	label	not set for Interlocks
	//	unit	not set for Interlocks
	//	standard_unit	not set for Interlocks
	//	display_unit	not set for Interlocks
	//	format	not set for Interlocks
	//	max_value	not set for Interlocks
	//	min_value	not set for Interlocks
	//	max_alarm	not set for Interlocks
	//	min_alarm	not set for Interlocks
	//	max_warning	not set for Interlocks
	//	min_warning	not set for Interlocks
	//	delta_t	not set for Interlocks
	//	delta_val	not set for Interlocks
	interlocks->set_default_properties(interlocks_prop);
	//	Not Polled
	interlocks->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(interlocks);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(DaresburyClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void DaresburyClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(DaresburyClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::pipe_factory_before
	/*----- PROTECTED REGION ID(DaresburyClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void DaresburyClass::command_factory()
{
	/*----- PROTECTED REGION ID(DaresburyClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::command_factory_before

	//	Set polling perod for command State
	Tango::Command	&stateCmd = get_cmd_by_name("State");
	stateCmd.set_polling_period(1000);
	

	//	Command DevRead
	DevReadClass	*pDevReadCmd =
		new DevReadClass("DevRead",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"",
			"Serial line response",
			Tango::OPERATOR);
	command_list.push_back(pDevReadCmd);

	//	Command GetAllDescription
	GetAllDescriptionClass	*pGetAllDescriptionCmd =
		new GetAllDescriptionClass("GetAllDescription",
			Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
			"",
			"List of interlock description",
			Tango::OPERATOR);
	command_list.push_back(pGetAllDescriptionCmd);

	//	Command GetHistoryInfo
	GetHistoryInfoClass	*pGetHistoryInfoCmd =
		new GetHistoryInfoClass("GetHistoryInfo",
			Tango::DEV_VOID, Tango::DEVVAR_LONGSTRINGARRAY,
			"",
			"Return a list of interlock logs [date,reason]",
			Tango::OPERATOR);
	command_list.push_back(pGetHistoryInfoCmd);

	//	Command GetInterlockDescription
	GetInterlockDescriptionClass	*pGetInterlockDescriptionCmd =
		new GetInterlockDescriptionClass("GetInterlockDescription",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_STRINGARRAY,
			"List of Interlock addresses : [Word address,Bit address]*",
			"Interlock descrition string array",
			Tango::OPERATOR);
	command_list.push_back(pGetInterlockDescriptionCmd);

	//	Command GetInterlockState
	GetInterlockStateClass	*pGetInterlockStateCmd =
		new GetInterlockStateClass("GetInterlockState",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_CHARARRAY,
			"List of Interlock addresses : [Word address,Bit address]*",
			"List of interlock state",
			Tango::OPERATOR);
	command_list.push_back(pGetInterlockStateCmd);

	//	Command ReadInterlockHistory
	ReadInterlockHistoryClass	*pReadInterlockHistoryCmd =
		new ReadInterlockHistoryClass("ReadInterlockHistory",
			Tango::DEV_LONG, Tango::DEVVAR_SHORTARRAY,
			"Log time , see GetHistoryInfo",
			"Array of interlock",
			Tango::OPERATOR);
	command_list.push_back(pReadInterlockHistoryCmd);

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command SetInterlockDescription
	SetInterlockDescriptionClass	*pSetInterlockDescriptionCmd =
		new SetInterlockDescriptionClass("SetInterlockDescription",
			Tango::DEVVAR_STRINGARRAY, Tango::DEV_VOID,
			"argin[0]=Word address\nargin[1]=Bit address\nargin[2]=Interlock description",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSetInterlockDescriptionCmd);

	//	Command EnableSMS
	EnableSMSClass	*pEnableSMSCmd =
		new EnableSMSClass("EnableSMS",
			Tango::DEVVAR_LONGARRAY, Tango::DEV_VOID,
			"argin[0]=Word address\nargin[1]=Bit address",
			"",
			Tango::OPERATOR);
	command_list.push_back(pEnableSMSCmd);

	//	Command DisableSMS
	DisableSMSClass	*pDisableSMSCmd =
		new DisableSMSClass("DisableSMS",
			Tango::DEVVAR_LONGARRAY, Tango::DEV_VOID,
			"argin[0]=Word address\nargin[1]=Bit address",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDisableSMSCmd);

	//	Command GetSMS
	GetSMSClass	*pGetSMSCmd =
		new GetSMSClass("GetSMS",
			Tango::DEVVAR_LONGARRAY, Tango::DEV_BOOLEAN,
			"argin[0]=Word address\nargin[1]=Bit address",
			"true if the SMS alarm is enabled for this interlock, false otherwise.",
			Tango::OPERATOR);
	command_list.push_back(pGetSMSCmd);

	/*----- PROTECTED REGION ID(DaresburyClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		DaresburyClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void DaresburyClass::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		std::transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(DaresburyClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		DaresburyClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void DaresburyClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		Daresbury *dev = static_cast<Daresbury *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(DaresburyClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DaresburyClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : DaresburyClass::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *DaresburyClass::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(DaresburyClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	DaresburyClass::Additional Methods
} //	namespace
